
#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cstdlib>
#include <algorithm>
#include <cstring>
using namespace std;
string s,w;
const int base1=307;
const int base2=239;
const int mod1=1e6+7;
const int mod2=1e6+9;
int n;
int f[2000000];
long long f1[2000000],f2[2000000],ans,pw1[2000000],pw2[2000000];
void buildhash() {
    for (int i=1;i<=n;i++) {
        f1[i]=f1[i-1]*base1+s[i-1]-'a'+1;
        f2[i]=f2[i-1]*base2+s[i-1]-'a'+1;
        f1[i]=f1[i]%mod1;
        f2[i]=f2[i]%mod2;
    }
}
int get_hash1(int l, int r) {
    l++;
    r++;
    long long hash1=f1[r]-f1[l-1]*pw1[r-l+1];
    hash1=hash1%mod1;
    if(hash1<0) hash1+=mod1;
    return hash1;
}
int get_hash2(int l, int r) {
    l++;
    r++;
    long long hash1=f2[r]-f2[l-1]*pw2[r-l+1];
    hash1=hash1%mod2;
    if(hash1<0) hash1+=mod2;
    return hash1;
}
void solve() {
    for (int k=1;k<ans;k++) {
        int l=k;
        if (k==7) {
            int qqq=0;
        }
        int used=0;
        while (l<n){
            if (f[l]>=min(k,n-l)) l+=k;
            else {
                if (used==1) {
                    used=2;
                    break;
                }
                int ll=l+f[l]+1;
                int rr=min(l+k,n-1);
                int hash1=get_hash1(ll,rr);
                int hash2=get_hash2(ll,rr);
                if (ll>rr) used=1;
                else {
                    int k1=get_hash1(ll-l-1,rr-l-1);
                    int k2=get_hash2(ll-l-1,rr-l-1);
                    if (k1!=hash1 || k2!=hash2) {
                        used=2;
                        break;
                    }
                    used=1;
                }
                l+=k+1;
            }
        }
        if (k<ans && used!=2) {
            ans=k;
            break;
        }
    }
}
int main() {
    freopen("periods.in","r",stdin);
    freopen("periods.out","w",stdout);
    ios_base::sync_with_stdio(0);
    cin >> s;
    n=s.size();
    //n=999999;
    //int ws=0;
   // srand(time(NULL));
   // int t=rand()%20000;
  //  w.assign("awat");
 /*   for (int i=0;i<n;i++) {
        if (i==t) s+='q';
        else {
            int p=i%w.size();
            if (i>t) p--;
            if (p<0) p+=w.size();
            s+=w[p];
        }
    }*/
    int l=0;
    int r=0;
    f[0]=0;
    for (int i=1;i<s.size();i++) {
        int k=0;
        if (l<=i && i<=r) k=min(f[i-l],r-i+1);
        while (i+k<s.size() && s[i+k]==s[k]) k++;
        f[i]=k;
        if (i+k-1>r) {
            r=i+k-1;
            l=i;
        }
    }
    pw1[0]=1;
    pw2[0]=1;
    for (int i=1;i<=n;i++) {
        pw1[i]=(pw1[i-1]*base1)%mod1;
        pw2[i]=(pw2[i-1]*base2)%mod2;
    }
    ans=n;
    buildhash();
    solve();
    reverse(s.begin(),s.end());
    f[0]=0;
    l=0;
    r=0;
    for (int i=1;i<s.size();i++) {
        int k=0;
        if (l<=i && i<=r) k=min(f[i-l],r-i+1);
        while (i+k<s.size() && s[i+k]==s[k]) k++;
        f[i]=k;
        if (i+k-1>r) {
            r=i+k-1;
            l=i;
        }
    }
    buildhash();
    solve();
    cout << ans << "\n";
    return 0;
}
