#include "bits/stdc++.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) (_x).begin(), (_x).end()
#define szof(_x) ((int) (_x).size())
#define TASK_NAME "teleports"

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

int n, m;
int l;
set <int> coords;
multiset <int> dists;

int add_coord(int x) {
    if (szof(coords) == 0) {
        coords.insert(x);
    } else {
        bool flag1 = false, flag2 = false;
        auto next = coords.upper_bound(x);
        if (next == coords.end()) {
            next = coords.begin();
            flag1 = true;
        }
        auto prev = coords.lower_bound(x);
        if (prev == coords.begin()) {
            prev = coords.end();
            flag2 = true;
        }
        --prev;        
        int tmp = *next - *prev;
        if (flag1 || flag2) {
            tmp = l + tmp;
        }
        dists.erase(dists.find(tmp));
        tmp = *next - x;
        if (flag1) {
            tmp = l + tmp;
        }
        dists.insert(tmp);
        tmp = x - *prev;
        if (flag2) {
            tmp = l + tmp;
        }
        dists.insert(tmp);
        coords.insert(x);
    }
    return 0;
}

int rem_coord(int x) {
    if (szof(coords) == 1) {
        coords.erase(x);
    } else {
        bool flag1 = false, flag2 = false;
        auto next = coords.upper_bound(x);
        if (next == coords.end()) {
            next = coords.begin();
            flag1 = true;
        }
        auto prev = coords.lower_bound(x);
        if (prev == coords.begin()) {
            prev = coords.end();
            flag2 = true;
        }
        --prev;
        int tmp = *next - *prev;
        if (flag1 || flag2) {
            tmp = l + tmp;
        }
        dists.insert(tmp);
        tmp = *next - x;
        if (flag1) {
            tmp = l + tmp;
        }
        dists.erase(dists.lower_bound(tmp));
        tmp = x - *prev;
        if (flag2) {
            tmp = l + tmp;
        }
        dists.erase(dists.lower_bound(tmp));
        coords.erase(x);
    }
    if (!szof(dists)) {
        dists.insert(l);
    }
    return 0;
}

int v;
int print_ans() {
    double d = 0;
    if (szof(dists) == 1) {
        d = l / 2.0;
    } else {
        auto tmp = dists.end();
        --tmp;
        d = *tmp;
        --tmp;
        d += *tmp;
        d /= 2;
    }
    printf("%.10f\n", d / v);    
    return 0;
}

int main() {        
    freopen(TASK_NAME ".in", "r", stdin);
    freopen(TASK_NAME ".out", "w", stdout);

    scanf("%d%d%d%d", &n, &m, &l, &v);

    dists.insert(l);
    for (int i = 0; i < n; ++i) {
        int num;
        scanf("%d", &num);
        add_coord(num);
    }

    print_ans();


    for (int i = 0; i < m; ++i) {
        char ch;
        int num;
        scanf("\n%c%d", &ch, &num);
        if (ch == '-') {
            rem_coord(num);
        } else {
            add_coord(num);
        }
        print_ans();
    }


    return 0;
}