import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import static ru.ifmo.testlib.Outcome.Type.*;

import java.util.ArrayList;
import java.util.Arrays;

public class Check implements Checker {

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        long tr = ans.nextLong();
        long ct = ouf.nextLong();
        if (tr != ct) {
            return new Outcome(Outcome.Type.WA, String.format("Expected %d, found: %d", tr, ct));        
        }
        return new Outcome(Outcome.Type.OK, String.format("OK %d", tr));
    }
}